local AuraSnapshot = {}

function AuraSnapshot:DoSnapshot()
	if type(AuraSnapshotSV) ~= "table" then
		AuraSnapshotSV = {}
	end
	
	local snapshot = {
		date = date(),
		GetTime = GetTime(),
		player = self:UnitSnapshot("player"),
		pet = self:UnitSnapshot("pet"),
		vehicle = self:UnitSnapshot("vehicle"),
		target = self:UnitSnapshot("target"),
		focus = self:UnitSnapshot("focus"),
	}
	table.insert(AuraSnapshotSV, snapshot)
end

function AuraSnapshot:UnitSnapshot(unit)
	if not UnitExists(unit) then
		return false
	end
	local snapshot = {
		name = UnitName(unit),
		UnitAura_HELPFUL = {},
		UnitAura_HARMFUL = {},
	}
	local i = 1
	while true do
		if UnitAura(unit, i, "HELPFUL") then
			snapshot.UnitAura_HELPFUL[i] = { UnitAura(unit, i, "HELPFUL") }
		else
			break
		end
		i = i + 1
	end
	i = 1
	while true do
		if UnitAura(unit, i, "HARMFUL") then
			snapshot.UnitAura_HARMFUL[i] = { UnitAura(unit, i, "HARMFUL") }
		else
			break
		end
		i = i + 1
	end
	return snapshot
end

local function slashfunc()
	AuraSnapshot:DoSnapshot()
end

SLASH_AuraSnapshot1 = "/aurass"
SlashCmdList["AuraSnapshot"] = slashfunc
